=== etc/CMakeLists.txt ===
add_subdirectory("systemd")
