=== debian/changelog ===
dnf5 (5.3.0.0-2) unstable; urgency=medium

  * autopkgtest: fix running on non-x86-64

 -- Luca Boccassi <bluca@debian.org>  Tue, 17 Feb 2026 01:26:22 +0000

dnf5 (5.3.0.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.3.0.0'
  * Drop priority from d/control, now defaults to optional
  * Drop Rules-Requires-Root, now defaults to no
  * Bump Standards-version to 4.7.3
  * Update d/copyright
  * Disable manifest plugin
  * libdnf5-cli: bump soname from 2 to 3

 -- Luca Boccassi <bluca@debian.org>  Mon, 16 Feb 2026 14:02:40 +0000

dnf5 (5.2.16.0-2) unstable; urgency=medium

  * Update d/copyright file to list all LGPL2.1+ files

 -- Luca Boccassi <bluca@debian.org>  Wed, 19 Nov 2025 18:40:33 +0000

dnf5 (5.2.16.0-1) unstable; urgency=medium

  * Initial release.

 -- Luca Boccassi <bluca@debian.org>  Tue, 12 Aug 2025 21:49:59 +0100
