=== debian/control ===
Source: dnf5
Section: admin
Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-package-notes,
 bash-completion,
 cmake,
 gettext,
 pkgconf,
 swig,
 systemd-dev,
 libappstream-dev,
 libfmt-dev,
 libjson-c-dev,
 libmodulemd-dev,
 librepo-dev (>= 1.20.0~),
 librpm-dev,
 libsdbus-c++-dev,
 libsmartcols-dev,
 libsolv-dev,
 libsolvext-dev,
 libsqlite3-dev,
 libtoml11-dev,
 libxml2-dev,
 zlib1g-dev,
 createrepo-c <!nocheck>,
 libcppunit-dev <!nocheck>,
 rpm <!nocheck>,
 python3-breathe <!nodoc>,
 python3-sphinx <!nodoc>,
Standards-Version: 4.7.3
Homepage: https://github.com/rpm-software-management/dnf5
Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/dnf5
Vcs-Git: https://salsa.debian.org/pkg-rpm-team/dnf5.git

Package: dnf5
Architecture: amd64 arm64 loong64 ppc64el riscv64 s390x
Depends: ${misc:Depends},
 ${shlibs:Depends},
 dnf-data,
 rpm,
Description: Dandified Yum package manager - version 5
 DNF5 is a command-line package manager that automates the process of
 installing, upgrading, configuring, and removing computer programs in a
 consistent manner. It supports RPM packages, modulemd modules, and comps groups
 & environments.
 .
 This package provides the dnf5 program.

Package: dnf5-server
Architecture: amd64 arm64 loong64 ppc64el riscv64 s390x
Depends: ${misc:Depends},
 ${shlibs:Depends},
 dnf5 (= ${binary:Version}),
Description: Dandified Yum package manager - version 5 server/client
 DNF5 is a command-line package manager that automates the process of
 installing, upgrading, configuring, and removing computer programs in a
 consistent manner. It supports RPM packages, modulemd modules, and comps groups
 & environments.
 .
 This package provides the dnf5 server and client programs.

Package: dnf5-dev
Section: devel
Architecture: amd64 arm64 loong64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${misc:Depends},
 libdnf5-cli-dev (= ${binary:Version}),
 libdnf5-dev (= ${binary:Version}),
Description: Dandified Yum package manager - version 5 development files
 DNF5 is a command-line package manager that automates the process of
 installing, upgrading, configuring, and removing computer programs in a
 consistent manner. It supports RPM packages, modulemd modules, and comps groups
 & environments.
 .
 This package provides the dnf5 development files.

Package: libdnf5-2
Section: libs
Architecture: amd64 arm64 loong64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${misc:Depends},
 ${shlibs:Depends},
Description: Dandified Yum package manager - version 5 library
 DNF5 is a command-line package manager that automates the process of
 installing, upgrading, configuring, and removing computer programs in a
 consistent manner. It supports RPM packages, modulemd modules, and comps groups
 & environments.
 .
 This package provides the libdnf5 library.

Package: libdnf5-dev
Section: libdevel
Architecture: amd64 arm64 loong64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${misc:Depends},
 libdnf5-2 (= ${binary:Version}),
 libfmt-dev,
 libmodulemd-dev,
 librepo-dev (>= 1.20.0~),
 librpm-dev,
 libsolv-dev,
 libsolvext-dev,
 libsqlite3-dev,
 libxml2-dev,
Description: Dandified Yum package manager - version 5 library development files
 DNF5 is a command-line package manager that automates the process of
 installing, upgrading, configuring, and removing computer programs in a
 consistent manner. It supports RPM packages, modulemd modules, and comps groups
 & environments.
 .
 This package provides the libdnf5 library development files.

Package: libdnf5-cli3
Section: libs
Architecture: amd64 arm64 loong64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${misc:Depends},
 ${shlibs:Depends},
Description: Dandified Yum package manager - version 5 CLI library
 DNF5 is a command-line package manager that automates the process of
 installing, upgrading, configuring, and removing computer programs in a
 consistent manner. It supports RPM packages, modulemd modules, and comps groups
 & environments.
 .
 This package provides the libdnf5 CLI library.

Package: libdnf5-cli-dev
Section: libdevel
Architecture: amd64 arm64 loong64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${misc:Depends},
 libdnf5-cli3 (= ${binary:Version}),
 libfmt-dev,
 libsmartcols-dev,
Description: Dandified Yum package manager - version 5 CLI development files
 DNF5 is a command-line package manager that automates the process of
 installing, upgrading, configuring, and removing computer programs in a
 consistent manner. It supports RPM packages, modulemd modules, and comps groups
 & environments.
 .
 This package provides the libdnf5 CLI library development files.
