=== debian/tests/control ===
Tests: bootstrap
Depends: dnf5, rpm
Restrictions: allow-stderr, needs-internet, needs-root
