=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/dnf-$1\.tar\.gz/ \
  https://github.com/rpm-software-management/dnf5/tags .*/@ANY_VERSION@\.tar\.gz
